# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with apiviz
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/seam/integration/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}

Name:           jboss-seam-int
Version:        5.1.0
Release:        2%{?dist}
Epoch:          0
Summary:        JBoss Seam Int
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# rm -rf jboss-seam-int-5.1.0 && svn export http://anonsvn.jboss.org/repos/jbossas/projects/jboss-seam-int/tags/5.1.0.GA/ jboss-seam-int-5.1.0 && tar cjf jboss-seam-int-5.1.0.tar.bz2 jboss-seam-int-5.1.0
# revision 106293.
Source0:        jboss-seam-int-5.1.0.tar.bz2
Source1:        jboss-seam-int-jpp-depmap.xml
Source2:        jboss-seam-int-settings.xml
Source3:        jboss-seam-int-component-info.xml
Patch0:         jboss-seam-int-no-apiviz.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
%if %with apiviz
BuildRequires:  apiviz
%endif
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
##
%if 0
  Path to dependency:
        1) org.jboss.seam.integration:jboss-seam-int-microcontainer:jar:5.1.0.CR1
        2) org.jboss.metadata:jboss-metadata:jar:1.0.0.CR18
        3) org.hibernate:ejb3-persistence:jar:1.0.2.GA
%endif
BuildRequires:  hibernate3-ejb-persistence-3.0-api
BuildRequires:  jbossas
BuildRequires:  jboss-cl >= 0:2.0.5
BuildRequires:  jboss-common-core >= 0:2.2.13
BuildRequires:  jboss-common-logging-spi >= 0:2.0.5
BuildRequires:  jboss-deployers >= 0:2.0.6
%if 0
  Path to dependency:
        1) org.jboss.seam.integration:jboss-seam-int-microcontainer:jar:5.1.0.CR1
        2) org.jboss.metadata:jboss-metadata:jar:1.0.0.CR18
        3) org.jboss.javaee:jboss-ejb-api:jar:3.0.0.GA
%endif
BuildRequires:  jboss-ejb-3.0-api >= 0:5.0.1
BuildRequires:  jboss-integration >= 0:5.0.3
%if 0
  Path to dependency:
        1) org.jboss.seam.integration:jboss-seam-int-microcontainer:jar:5.1.0.CR1
        2) org.jboss.metadata:jboss-metadata:jar:1.0.0.CR18
        3) org.jboss.javaee:jboss-jms-api:jar:1.1.0.GA
%endif
BuildRequires:  jboss-jms-1.1-api >= 0:5.0.1
BuildRequires:  jboss-man >= 0:2.1.0-0.CR8
BuildRequires:  jboss-metadata >= 0:1.0.0-0.CR18
BuildRequires:  jboss-microcontainer2 >= 0:2.0.5
BuildRequires:  jboss-parent >= 0:4
%if 0
  Path to dependency:
        1) org.jboss.seam.integration:jboss-seam-int-microcontainer:jar:5.1.0.CR1
        2) org.jboss.microcontainer:jboss-dependency:jar:2.0.5.GA
        3) org.jboss:jboss-reflect:jar:2.0.2.GA
%endif
BuildRequires:  jboss-reflect >= 0:2.0.2
BuildRequires:  jboss-seam2 >= 0:2.1.1
%if 0
  Path to dependency:
        1) org.jboss.seam.integration:jboss-seam-int-microcontainer:jar:5.1.0.CR1
        2) org.jboss.test:jboss-test:jar:1.1.1.GA
        3) org.jboss.jbossas:jboss-server-manager:jar:1.0.2.GA
        4) org.jboss.security:jboss-security-spi:jar:2.0.3.SP1
%endif
BuildRequires:   jboss-security-spi >= 0:2.0.3
%if 0
  Path to dependency:
        1) org.jboss.seam.integration:jboss-seam-int-microcontainer:jar:5.1.0.CR1
        2) org.jboss.test:jboss-test:jar:1.1.1.GA
        3) org.jboss.jbossas:jboss-server-manager:jar:1.0.2.GA
        4) org.jboss.security:jbosssx-client:jar:2.0.3.SP1
%endif
BuildRequires: jbosssx2 >= 0:2.0.3
%if 0
  Path to dependency:
        1) org.jboss.seam.integration:jboss-seam-int-microcontainer:jar:5.1.0.CR1
        2) org.jboss.metadata:jboss-metadata:jar:1.0.0.CR18
        3) org.jboss.javaee:jboss-transaction-api:jar:1.0.1.GA
%endif
BuildRequires:  jboss-transaction-1.0.1-api >= 0:5.0.1
BuildRequires:  jboss-vfs2 >= 0:2.1.1
%if 0
  Path to dependency:
        1) org.jboss.seam.integration:jboss-seam-int-microcontainer:jar:5.1.0.CR1
        2) org.jboss.metadata:jboss-metadata:jar:1.0.0.CR18
        3) jboss.jbossws:jboss-jaxws:jar:3.0.1-native-2.0.4.GA
%endif
BuildRequires:  jbossws >= 0:3.0.1
BuildRequires:  jbossxb2 >= 0:2.0.1
# FIXME: should use jbossweb2
BuildRequires:  servlet_2_5_api
BuildRequires:  jboss-test >= 0:1.1.1
BuildRequires:  junit44
##
%if 0
Requires:       java >= 0:1.5.0
Requires:       jboss-cl >= 0:2.0.5
Requires:       jboss-common-core >= 0:2.2.13
Requires:       jboss-common-logging-spi >= 0:2.0.5
Requires:       jboss-deployers >= 0:2.0.6
Requires:       jboss-integration >= 0:5.0.3
Requires:       jboss-man >= 0:2.1.0-0.CR8
Requires:       jboss-metadata >= 0:1.0.0-0.CR18
Requires:       jboss-microcontainer2 >= 0:2.0.5
Requires:       jboss-parent >= 0:4
Requires:       jboss-seam2 >= 0:2.1.1
Requires:       jboss-vfs2 >= 0:2.1.1
Requires:       jbossxb2 >= 0:2.0.1
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Seam Int.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%if %without apiviz
%patch0 -p0 -b .sav0
%endif
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}/%{name}
cp -p jbossas/target/jboss-seam-int-jbossas.jar %{buildroot}%{_javadir}/%{name}/%{name}-jbossas-%{version}.jar
cp -p jbossas/target/jboss-seam-int-jbossas-sources.jar %{buildroot}%{_javadir}/%{name}/%{name}-jbossas-sources-%{version}.jar
cp -p microcontainer/target/jboss-seam-int-microcontainer.jar %{buildroot}%{_javadir}/%{name}/%{name}-microcontainer-%{version}.jar
cp -p microcontainer/target/jboss-seam-int-microcontainer-sources.jar %{buildroot}%{_javadir}/%{name}/%{name}-microcontainer-sources-%{version}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom
%add_to_maven_depmap org.jboss.seam.integration jboss-seam-int %{namedversion} JPP/%{name} %{name}
cp -p build/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-dist.pom
%add_to_maven_depmap org.jboss.seam.integration jboss-seam-int-dist %{namedversion} JPP/%{name} %{name}-dist
cp -p jbossas/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-jbossas.pom
%add_to_maven_depmap org.jboss.seam.integration jboss-seam-int-jbossas %{namedversion} JPP/%{name} %{name}-jbossas
cp -p microcontainer/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-microcontainer.pom
%add_to_maven_depmap org.jboss.seam.integration jboss-seam-int-microcontainer %{namedversion} JPP/%{name} %{name}-microcontainer

mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
%if %without apiviz
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
%endif
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom %{buildroot}%{repodirlib}/%{name}.pom
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-dist.pom %{buildroot}%{repodirlib}/%{name}-dist.pom
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-jbossas.pom %{buildroot}%{repodirlib}/%{name}-jbossas.pom
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-microcontainer.pom %{buildroot}%{repodirlib}/%{name}-microcontainer.pom
cp -p %{buildroot}%{_javadir}/%{name}/%{name}-jbossas.jar %{buildroot}%{repodirlib}/jboss-seam-int-jbossas.jar
cp -p %{buildroot}%{_javadir}/%{name}/%{name}-jbossas-sources.jar %{buildroot}%{repodirlib}/jboss-seam-int-jbossas-sources.jar
cp -p %{buildroot}%{_javadir}/%{name}/%{name}-microcontainer.jar %{buildroot}%{repodirlib}/jboss-seam-int-microcontainer.jar
cp -p %{buildroot}%{_javadir}/%{name}/%{name}-microcontainer-sources.jar %{buildroot}%{repodirlib}/jboss-seam-int-microcontainer-sources.jar
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}*/%{name}/jboss-seam-int-jbossas-%{version}.jar
%{_javadir}*/%{name}/jboss-seam-int-jbossas.jar
%{_javadir}*/%{name}/jboss-seam-int-jbossas-sources-%{version}.jar
%{_javadir}*/%{name}/jboss-seam-int-jbossas-sources.jar
%{_javadir}*/%{name}/jboss-seam-int-microcontainer-%{version}.jar
%{_javadir}*/%{name}/jboss-seam-int-microcontainer.jar
%{_javadir}*/%{name}/jboss-seam-int-microcontainer-sources-%{version}.jar
%{_javadir}*/%{name}/jboss-seam-int-microcontainer-sources.jar
%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom
%{_datadir}/maven2/poms/JPP.%{name}-%{name}-dist.pom
%{_datadir}/maven2/poms/JPP.%{name}-%{name}-jbossas.pom
%{_datadir}/maven2/poms/JPP.%{name}-%{name}-microcontainer.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Dec 14 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-2
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-site-plugin

* Fri Jun 25 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-1
- 5.1.0.GA

* Tue Jun 22 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-0.CR1.4
- rebuild with javadocs (disable apiviz)

* Tue Apr 13 2010 Yiqiao Wang <yiwang@redhat.com> 0:5.1.0-0.CR1.1.3.1
- Rebuild
- Fix depmap entry for dtdparser

* Wed Sep 16 2009 Fernando Nasser <fnasser@redhat.com> 0:5.1.0-0.CR1.1.3
- Relax run-time dependencies, all provided by the AS environment

* Mon Sep 14 2009 David Walluck <dwalluck@redhat.com> 0:5.1.0-0.CR1.1.2
- BuildRequires: hibernate3-ejb-persistence-3.0-api
- add jpp depmap entry for stax_1_0_api

* Fri Sep 11 2009 David Walluck <dwalluck@redhat.com> 0:5.1.0-0.CR1.1.1
- disable javadoc to drop apiviz requirement
- don't ignore test failures
- update jpp depmap for jbossws

* Fri Sep 11 2009 David Walluck <dwalluck@redhat.com> 0:5.1.0-0.CR1.1
- release
